Index: /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/MemPRContext.cs
===================================================================
--- /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/MemPRContext.cs	(revision 14543)
+++ /branches/MemPRAlgorithm/HeuristicLab.Algorithms.MemPR/3.3/MemPRContext.cs	(revision 14544)
@@ -23,4 +23,7 @@
 using System.Collections.Generic;
 using System.Linq;
+using System.Runtime.CompilerServices;
+using System.Threading;
+using HeuristicLab.Algorithms.DataAnalysis;
 using HeuristicLab.Algorithms.MemPR.Interfaces;
 using HeuristicLab.Common;
@@ -30,5 +33,7 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis;
 using HeuristicLab.Random;
+using ExecutionContext = HeuristicLab.Core.ExecutionContext;
 
 namespace HeuristicLab.Algorithms.MemPR {
@@ -123,4 +128,11 @@
 
     [Storable]
+    private IValueParameter<IntValue> byDelinking;
+    public int ByDelinking {
+      get { return byDelinking.Value.Value; }
+      set { byDelinking.Value.Value = value; }
+    }
+
+    [Storable]
     private IValueParameter<IntValue> bySampling;
     public int BySampling {
@@ -137,8 +149,8 @@
 
     [Storable]
-    private IValueParameter<IntValue> byTabuwalking;
-    public int ByTabuwalking {
-      get { return byTabuwalking.Value.Value; }
-      set { byTabuwalking.Value.Value = value; }
+    private IValueParameter<IntValue> byAdaptivewalking;
+    public int ByAdaptivewalking {
+      get { return byAdaptivewalking.Value.Value; }
+      set { byAdaptivewalking.Value.Value = value; }
     }
 
@@ -162,8 +174,16 @@
       return scope.SubScopes[index] as ISingleObjectiveSolutionScope<TSolution>;
     }
+    public void SortPopulation() {
+      scope.SubScopes.Replace(scope.SubScopes.OfType<ISingleObjectiveSolutionScope<TSolution>>().OrderBy(x => Problem.Maximization ? -x.Fitness : x.Fitness).ToList());
+    }
     public int PopulationCount {
       get { return scope.SubScopes.Count; }
     }
 
+    [Storable]
+    private IConfidenceRegressionModel breedingPerformanceModel;
+    public IConfidenceRegressionModel BreedingPerformanceModel {
+      get { return breedingPerformanceModel; }
+    }
     [Storable]
     private List<Tuple<double, double, double>> breedingStat;
@@ -172,4 +192,39 @@
     }
     [Storable]
+    private IConfidenceRegressionModel relinkingPerformanceModel;
+    public IConfidenceRegressionModel RelinkingPerformanceModel {
+      get { return relinkingPerformanceModel; }
+    }
+    [Storable]
+    private List<Tuple<double, double, double>> relinkingStat;
+    public List<Tuple<double, double, double>> RelinkingStat {
+      get { return relinkingStat; }
+    }
+    [Storable]
+    private IConfidenceRegressionModel delinkingPerformanceModel;
+    public IConfidenceRegressionModel DelinkingPerformanceModel {
+      get { return delinkingPerformanceModel; }
+    }
+    [Storable]
+    private List<Tuple<double, double, double>> delinkingStat;
+    public List<Tuple<double, double, double>> DelinkingStat {
+      get { return delinkingStat; }
+    }
+    [Storable]
+    private IConfidenceRegressionModel samplingPerformanceModel;
+    public IConfidenceRegressionModel SamplingPerformanceModel {
+      get { return samplingPerformanceModel; }
+    }
+    [Storable]
+    private List<Tuple<double, double>> samplingStat;
+    public List<Tuple<double, double>> SamplingStat {
+      get { return samplingStat; }
+    }
+    [Storable]
+    private IConfidenceRegressionModel hillclimbingPerformanceModel;
+    public IConfidenceRegressionModel HillclimbingPerformanceModel {
+      get { return hillclimbingPerformanceModel; }
+    }
+    [Storable]
     private List<Tuple<double, double>> hillclimbingStat;
     public List<Tuple<double, double>> HillclimbingStat {
@@ -177,7 +232,12 @@
     }
     [Storable]
-    private List<Tuple<double, double>> tabuwalkingStat;
-    public List<Tuple<double, double>> TabuwalkingStat {
-      get { return tabuwalkingStat; }
+    private IConfidenceRegressionModel adaptiveWalkPerformanceModel;
+    public IConfidenceRegressionModel AdaptiveWalkPerformanceModel {
+      get { return adaptiveWalkPerformanceModel; }
+    }
+    [Storable]
+    private List<Tuple<double, double>> adaptivewalkingStat;
+    public List<Tuple<double, double>> AdaptivewalkingStat {
+      get { return adaptivewalkingStat; }
     }
 
@@ -199,12 +259,22 @@
       byBreeding = cloner.Clone(original.byBreeding);
       byRelinking = cloner.Clone(original.byRelinking);
+      byDelinking = cloner.Clone(original.byDelinking);
       bySampling = cloner.Clone(original.bySampling);
       byHillclimbing = cloner.Clone(original.byHillclimbing);
-      byTabuwalking = cloner.Clone(original.byTabuwalking);
+      byAdaptivewalking = cloner.Clone(original.byAdaptivewalking);
       random = cloner.Clone(original.random);
+      breedingPerformanceModel = cloner.Clone(original.breedingPerformanceModel);
       breedingStat = original.breedingStat.Select(x => Tuple.Create(x.Item1, x.Item2, x.Item3)).ToList();
+      relinkingPerformanceModel = cloner.Clone(original.relinkingPerformanceModel);
+      relinkingStat = original.relinkingStat.Select(x => Tuple.Create(x.Item1, x.Item2, x.Item3)).ToList();
+      delinkingPerformanceModel = cloner.Clone(original.delinkingPerformanceModel);
+      delinkingStat = original.delinkingStat.Select(x => Tuple.Create(x.Item1, x.Item2, x.Item3)).ToList();
+      samplingPerformanceModel = cloner.Clone(original.samplingPerformanceModel);
+      samplingStat = original.samplingStat.Select(x => Tuple.Create(x.Item1, x.Item2)).ToList();
+      hillclimbingPerformanceModel = cloner.Clone(original.hillclimbingPerformanceModel);
       hillclimbingStat = original.hillclimbingStat.Select(x => Tuple.Create(x.Item1, x.Item2)).ToList();
-      tabuwalkingStat = original.tabuwalkingStat.Select(x => Tuple.Create(x.Item1, x.Item2)).ToList();
-
+      adaptiveWalkPerformanceModel = cloner.Clone(original.adaptiveWalkPerformanceModel);
+      adaptivewalkingStat = original.adaptivewalkingStat.Select(x => Tuple.Create(x.Item1, x.Item2)).ToList();
+      
       Model = cloner.Clone(original.Model);
     }
@@ -222,12 +292,16 @@
       Parameters.Add(byBreeding = new ValueParameter<IntValue>("ByBreeding", new IntValue(0)));
       Parameters.Add(byRelinking = new ValueParameter<IntValue>("ByRelinking", new IntValue(0)));
+      Parameters.Add(byDelinking = new ValueParameter<IntValue>("ByDelinking", new IntValue(0)));
       Parameters.Add(bySampling = new ValueParameter<IntValue>("BySampling", new IntValue(0)));
       Parameters.Add(byHillclimbing = new ValueParameter<IntValue>("ByHillclimbing", new IntValue(0)));
-      Parameters.Add(byTabuwalking = new ValueParameter<IntValue>("ByTabuwalking", new IntValue(0)));
+      Parameters.Add(byAdaptivewalking = new ValueParameter<IntValue>("ByAdaptivewalking", new IntValue(0)));
       Parameters.Add(random = new ValueParameter<IRandom>("Random", new MersenneTwister()));
 
       breedingStat = new List<Tuple<double, double, double>>();
+      relinkingStat = new List<Tuple<double, double, double>>();
+      delinkingStat = new List<Tuple<double, double, double>>();
+      samplingStat = new List<Tuple<double, double>>();
       hillclimbingStat = new List<Tuple<double, double>>();
-      tabuwalkingStat = new List<Tuple<double, double>>();
+      adaptivewalkingStat = new List<Tuple<double, double>>();
     }
 
@@ -239,4 +313,342 @@
     }
 
+    public void RelearnBreedingPerformanceModel() {
+      breedingPerformanceModel = RunRegression(PrepareRegression(BreedingStat), breedingPerformanceModel).Model;
+    }
+    public bool BreedingSuited(ISingleObjectiveSolutionScope<TSolution> p1, ISingleObjectiveSolutionScope<TSolution> p2) {
+      if (breedingPerformanceModel == null) return true;
+      double minI1 = double.MaxValue, minI2 = double.MaxValue, maxI1 = double.MinValue, maxI2 = double.MinValue;
+      foreach (var d in BreedingStat) {
+        if (d.Item1 < minI1) minI1 = d.Item1;
+        if (d.Item1 > maxI1) maxI1 = d.Item1;
+        if (d.Item2 < minI2) minI2 = d.Item2;
+        if (d.Item2 > maxI2) maxI2 = d.Item2;
+      }
+      if (IsBetter(p1, p2)) {
+        if (p1.Fitness < minI1 || p1.Fitness > maxI1 || p2.Fitness < minI2 || p2.Fitness > maxI2)
+          return true;
+        return Random.NextDouble() < ProbabilityAccept3dModel(p1.Fitness, p2.Fitness, breedingPerformanceModel);
+      }
+      if (p1.Fitness < minI2 || p1.Fitness > maxI2 || p2.Fitness < minI1 || p2.Fitness > maxI1)
+        return true;
+      return Random.NextDouble() < ProbabilityAccept3dModel(p2.Fitness, p1.Fitness, breedingPerformanceModel);
+    }
+
+    public void RelearnRelinkingPerformanceModel() {
+      relinkingPerformanceModel = RunRegression(PrepareRegression(RelinkingStat), relinkingPerformanceModel).Model;
+    }
+    public bool RelinkSuited(ISingleObjectiveSolutionScope<TSolution> p1, ISingleObjectiveSolutionScope<TSolution> p2) {
+      if (relinkingPerformanceModel == null) return true;
+      double minI1 = double.MaxValue, minI2 = double.MaxValue, maxI1 = double.MinValue, maxI2 = double.MinValue;
+      foreach (var d in RelinkingStat) {
+        if (d.Item1 < minI1) minI1 = d.Item1;
+        if (d.Item1 > maxI1) maxI1 = d.Item1;
+        if (d.Item2 < minI2) minI2 = d.Item2;
+        if (d.Item2 > maxI2) maxI2 = d.Item2;
+      }
+      if (IsBetter(p1, p2)) {
+        if (p1.Fitness < minI1 || p1.Fitness > maxI1 || p2.Fitness < minI2 || p2.Fitness > maxI2)
+          return true;
+        return Random.NextDouble() < ProbabilityAccept3dModel(p1.Fitness, p2.Fitness, relinkingPerformanceModel);
+      }
+      if (p1.Fitness < minI2 || p1.Fitness > maxI2 || p2.Fitness < minI1 || p2.Fitness > maxI1)
+        return true;
+      return Random.NextDouble() < ProbabilityAccept3dModel(p2.Fitness, p1.Fitness, relinkingPerformanceModel);
+    }
+
+    public void RelearnDelinkingPerformanceModel() {
+      delinkingPerformanceModel = RunRegression(PrepareRegression(DelinkingStat), delinkingPerformanceModel).Model;
+    }
+    public bool DelinkSuited(ISingleObjectiveSolutionScope<TSolution> p1, ISingleObjectiveSolutionScope<TSolution> p2) {
+      if (delinkingPerformanceModel == null) return true;
+      double minI1 = double.MaxValue, minI2 = double.MaxValue, maxI1 = double.MinValue, maxI2 = double.MinValue;
+      foreach (var d in DelinkingStat) {
+        if (d.Item1 < minI1) minI1 = d.Item1;
+        if (d.Item1 > maxI1) maxI1 = d.Item1;
+        if (d.Item2 < minI2) minI2 = d.Item2;
+        if (d.Item2 > maxI2) maxI2 = d.Item2;
+      }
+      if (IsBetter(p1, p2)) {
+        if (p1.Fitness < minI1 || p1.Fitness > maxI1 || p2.Fitness < minI2 || p2.Fitness > maxI2)
+          return true;
+        return Random.NextDouble() < ProbabilityAccept3dModel(p1.Fitness, p2.Fitness, delinkingPerformanceModel);
+      }
+      if (p1.Fitness < minI2 || p1.Fitness > maxI2 || p2.Fitness < minI1 || p2.Fitness > maxI1)
+        return true;
+      return Random.NextDouble() < ProbabilityAccept3dModel(p2.Fitness, p1.Fitness, delinkingPerformanceModel);
+    }
+
+    public void RelearnSamplingPerformanceModel() {
+      samplingPerformanceModel = RunRegression(PrepareRegression(SamplingStat), samplingPerformanceModel).Model;
+    }
+    public bool SamplingSuited() {
+      if (samplingPerformanceModel == null) return true;
+      return Random.NextDouble() < ProbabilityAccept2dModel(Population.Average(x => x.Fitness), samplingPerformanceModel);
+    }
+
+    public void RelearnHillclimbingPerformanceModel() {
+      hillclimbingPerformanceModel = RunRegression(PrepareRegression(HillclimbingStat), hillclimbingPerformanceModel).Model;
+    }
+    public bool HillclimbingSuited(ISingleObjectiveSolutionScope<TSolution> scope) {
+      if (hillclimbingPerformanceModel == null) return true;
+      if (scope.Fitness < HillclimbingStat.Min(x => x.Item1) || scope.Fitness > HillclimbingStat.Max(x => x.Item1))
+        return true;
+      return Random.NextDouble() < ProbabilityAccept2dModel(scope.Fitness, hillclimbingPerformanceModel);
+    }
+    public bool HillclimbingSuited(double startingFitness) {
+      if (hillclimbingPerformanceModel == null) return true;
+      if (startingFitness < HillclimbingStat.Min(x => x.Item1) || startingFitness > HillclimbingStat.Max(x => x.Item1))
+        return true;
+      return Random.NextDouble() < ProbabilityAccept2dModel(startingFitness, hillclimbingPerformanceModel);
+    }
+
+    public void RelearnAdaptiveWalkPerformanceModel() {
+      adaptiveWalkPerformanceModel = RunRegression(PrepareRegression(AdaptivewalkingStat), adaptiveWalkPerformanceModel).Model;
+    }
+    public bool AdaptivewalkingSuited(ISingleObjectiveSolutionScope<TSolution> scope) {
+      if (adaptiveWalkPerformanceModel == null) return true;
+      if (scope.Fitness < AdaptivewalkingStat.Min(x => x.Item1) || scope.Fitness > AdaptivewalkingStat.Max(x => x.Item1))
+        return true;
+      return Random.NextDouble() < ProbabilityAccept2dModel(scope.Fitness, adaptiveWalkPerformanceModel);
+    }
+    public bool AdaptivewalkingSuited(double startingFitness) {
+      if (adaptiveWalkPerformanceModel == null) return true;
+      if (startingFitness < AdaptivewalkingStat.Min(x => x.Item1) || startingFitness > AdaptivewalkingStat.Max(x => x.Item1))
+        return true;
+      return Random.NextDouble() < ProbabilityAccept2dModel(startingFitness, adaptiveWalkPerformanceModel);
+    }
+
+    public IConfidenceRegressionSolution GetSolution(IConfidenceRegressionModel model, List<Tuple<double, double>> data) {
+      return new ConfidenceRegressionSolution(model, PrepareRegression(data));
+    }
+    public IConfidenceRegressionSolution GetSolution(IConfidenceRegressionModel model, List<Tuple<double, double, double>> data) {
+      return new ConfidenceRegressionSolution(model, PrepareRegression(data));
+    }
+
+    protected RegressionProblemData PrepareRegression(List<Tuple<double, double>> sample) {
+      var inCol = new List<double>();
+      var outCol = new List<double>();
+      foreach (var next in sample.Shuffle(Random)) {
+        inCol.Add(next.Item1);
+        outCol.Add(next.Item2);
+      }
+      var ds = new Dataset(new[] { "in", "out" }, new[] { inCol, outCol });
+      var regPrb = new RegressionProblemData(ds, new[] { "in" }, "out") {
+        TrainingPartition = { Start = 0, End = Math.Min(50, sample.Count) },
+        TestPartition = { Start = Math.Min(50, sample.Count), End = sample.Count }
+      };
+      return regPrb;
+    }
+
+    protected RegressionProblemData PrepareRegression(List<Tuple<double, double, double>> sample) {
+      var in1Col = new List<double>();
+      var in2Col = new List<double>();
+      var outCol = new List<double>();
+      foreach (var next in sample.Shuffle(Random)) {
+        in1Col.Add(next.Item1);
+        in2Col.Add(next.Item2);
+        outCol.Add(next.Item3);
+      }
+      var ds = new Dataset(new[] { "in1", "in2", "out" }, new[] { in1Col, in2Col, outCol });
+      var regPrb = new RegressionProblemData(ds, new[] { "in1", "in2" }, "out") {
+        TrainingPartition = { Start = 0, End = Math.Min(50, sample.Count) },
+        TestPartition = { Start = Math.Min(50, sample.Count), End = sample.Count }
+      };
+      return regPrb;
+    }
+
+    protected static IConfidenceRegressionSolution RunRegression(RegressionProblemData trainingData, IConfidenceRegressionModel baseLineModel = null) {
+      var baseline = baseLineModel != null ? new ConfidenceRegressionSolution(baseLineModel, trainingData) : null;
+      var gpr = new GaussianProcessRegression { Problem = { ProblemData = trainingData } };
+      if (trainingData.InputVariables.CheckedItems.Any(x => alglib.pearsoncorr2(trainingData.Dataset.GetDoubleValues(x.Value.Value).ToArray(), trainingData.TargetVariableValues.ToArray()) > 0.8)) {
+        gpr.MeanFunction = new MeanZero();
+        var cov1 = new CovarianceSum();
+        cov1.Terms.Add(new CovarianceLinearArd());
+        cov1.Terms.Add(new CovarianceConst());
+        gpr.CovarianceFunction = cov1;
+      }
+      IConfidenceRegressionSolution solution = null;
+      var cnt = 0;
+      do {
+        ExecuteAlgorithm(gpr);
+        solution = (IConfidenceRegressionSolution)gpr.Results["Solution"].Value;
+        cnt++;
+      } while (cnt < 10 && (solution == null || solution.TrainingRSquared.IsAlmost(0)));
+      if (baseline == null) return solution;
+      if (trainingData.Dataset.Rows < 60)
+        return solution.TrainingMeanAbsoluteError < baseline.TrainingMeanAbsoluteError ? solution : baseline;
+      return solution.TestMeanAbsoluteError < baseline.TestMeanAbsoluteError ? solution : baseline;
+    }
+
+    protected static void ExecuteAlgorithm(IAlgorithm algorithm) {
+      using (var evt = new AutoResetEvent(false)) {
+        EventHandler exeStateChanged = (o, args) => {
+          if (algorithm.ExecutionState == ExecutionState.Paused || algorithm.ExecutionState == ExecutionState.Stopped)
+            evt.Set();
+        };
+        algorithm.ExecutionStateChanged += exeStateChanged;
+        algorithm.Prepare(true);
+        algorithm.Start();
+        evt.WaitOne();
+        algorithm.ExecutionStateChanged -= exeStateChanged;
+      }
+    }
+
+    protected double ProbabilityAccept(ISingleObjectiveSolutionScope<TSolution> scope, IList<Tuple<double, double>> data) {
+      if (double.IsNaN(scope.Fitness)) throw new ArgumentException("solution not evaluated or quality unknown", "scope");
+      return ProbabilityAccept2d(scope.Fitness, data);
+    }
+
+    private double ProbabilityAccept2dModel(double a, IConfidenceRegressionModel model) {
+      var ds = new Dataset(new[] { "in", "out" }, new[] { new List<double> { a }, new List<double> { double.NaN } });
+      var mean = model.GetEstimatedValues(ds, new[] { 0 }).Single();
+      var sdev = Math.Sqrt(model.GetEstimatedVariances(ds, new[] { 0 }).Single());
+
+      var goal = Problem.Maximization ? Population.Min(x => x.Fitness) : Population.Max(x => x.Fitness);
+      var z = (goal - mean) / sdev;
+      return Problem.Maximization ? 1.0 - Phi(z) /* P(X >= z) */ : Phi(z); // P(X <= z)
+    }
+    protected double ProbabilityAccept2d(double startingFitness, IList<Tuple<double, double>> data) {
+      if (data.Count < 10) return 1.0;
+      var samples = 0;
+      double meanStart = 0, meanStartOld = 0, meanEnd = 0, meanEndOld = 0;
+      double varStart = 0, varStartOld = 0, varEnd = 0, varEndOld = 0;
+      for (var i = 0; i < data.Count; i++) {
+        samples++;
+        var x = data[i].Item1;
+        var y = data[i].Item2;
+
+        if (samples == 1) {
+          meanStartOld = x;
+          meanEndOld = y;
+        } else {
+          meanStart = meanStartOld + (x - meanStartOld) / samples;
+          meanEnd = meanEndOld + (y - meanEndOld) / samples;
+          varStart = varStartOld + (x - meanStartOld) * (x - meanStart) / (samples - 1);
+          varEnd = varEndOld + (y - meanEndOld) * (y - meanEnd) / (samples - 1);
+
+          meanStartOld = meanStart;
+          meanEndOld = meanEnd;
+          varStartOld = varStart;
+          varEndOld = varEnd;
+        }
+      }
+      var cov = data.Select((v, i) => new { Index = i, Value = v }).Select(x => x.Value).Sum(x => (x.Item1 - meanStart) * (x.Item2 - meanEnd)) / data.Count;
+
+      var biasedMean = meanEnd + cov / varStart * (startingFitness - meanStart);
+      var biasedStdev = Math.Sqrt(varEnd - (cov * cov) / varStart);
+
+      if (Problem.Maximization) {
+        var goal = Population.Min(x => x.Fitness);
+        var z = (goal - biasedMean) / biasedStdev;
+        return 1.0 - Phi(z); // P(X >= z)
+      } else {
+        var goal = Population.Max(x => x.Fitness);
+        var z = (goal - biasedMean) / biasedStdev;
+        return Phi(z); // P(X <= z)
+      }
+    }
+
+    private double ProbabilityAccept3dModel(double a, double b, IConfidenceRegressionModel model) {
+      var ds = new Dataset(new[] { "in1", "in2", "out" }, new[] { new List<double> { a }, new List<double> { b }, new List<double> { double.NaN } });
+      var mean = model.GetEstimatedValues(ds, new[] { 0 }).Single();
+      var sdev = Math.Sqrt(model.GetEstimatedVariances(ds, new[] { 0 }).Single());
+
+      var goal = Problem.Maximization ? Population.Min(x => x.Fitness) : Population.Max(x => x.Fitness);
+      var z = (goal - mean) / sdev;
+      return Problem.Maximization ? 1.0 - Phi(z) /* P(X >= z) */ : Phi(z); // P(X <= z)
+    }
+    protected double ProbabilityAccept3d(double startingFitness1, double startingFitness2, IList<Tuple<double, double, double>> data) {
+      if (data.Count < 20) return 1.0;
+      var samples = 0;
+      double meanX1 = 0, meanX1Old = 0, meanX2 = 0, meanX2Old = 0, meanY = 0, meanYOld = 0;
+      double varX1 = 0, varX1Old = 0, varX2 = 0, varX2Old = 0, varY = 0, varYOld = 0;
+      for (var i = 0; i < data.Count; i++) {
+        samples++;
+        var x1 = data[i].Item1;
+        var x2 = data[i].Item2;
+        var y = data[i].Item3;
+
+        if (samples == 1) {
+          meanX1Old = x1;
+          meanX2Old = x2;
+          meanYOld = y;
+        } else {
+          meanX1 = meanX1Old + (x1 - meanX1Old) / samples;
+          meanX2 = meanX2Old + (x2 - meanX2Old) / samples;
+          meanY = meanYOld + (y - meanYOld) / samples;
+          varX1 = varX1Old + (x1 - meanX1Old) * (x1 - meanX1) / (samples - 1);
+          varX2 = varX2Old + (x2 - meanX2Old) * (x2 - meanX2) / (samples - 1);
+          varY = varYOld + (y - meanYOld) * (y - meanY) / (samples - 1);
+
+          meanX1Old = meanX1;
+          meanX2Old = meanX2;
+          meanYOld = meanY;
+          varX1Old = varX1;
+          varX2Old = varX2;
+          varYOld = varY;
+        }
+      }
+      double covX1X2 = 0, covX1Y = 0, covX2Y = 0;
+      for (var i = 0; i < data.Count; i++) {
+        covX1X2 += (data[i].Item1 - meanX1) * (data[i].Item2 - meanX2) / data.Count;
+        covX1Y += (data[i].Item1 - meanX1) * (data[i].Item3 - meanY) / data.Count;
+        covX2Y += (data[i].Item2 - meanX2) * (data[i].Item3 - meanY) / data.Count;
+      }
+
+      var biasedMean = meanY + ((covX1Y * varX2 - covX2Y * covX1X2) * (startingFitness1 - meanX1) - (covX1Y * covX1X2 - covX2Y * varX1) * (startingFitness2 - meanX2)) / (varX1 * varX2 - covX1X2 * covX1X2);
+      var biasedStdev = Math.Sqrt(varY - (covX1Y * covX1Y * varX2 - 2 * covX1Y * covX2Y * covX1X2 + covX2Y * covX2Y * varX1) / (varX1 * varX2 - covX1X2 * covX1X2));
+      if (Problem.Maximization) {
+        var goal = Population.Min(x => x.Fitness);
+        var z = (goal - biasedMean) / biasedStdev;
+        return 1.0 - Phi(z); // P(X >= z)
+      } else {
+        var goal = Population.Max(x => x.Fitness);
+        var z = (goal - biasedMean) / biasedStdev;
+        return Phi(z); // P(X <= z)
+      }
+    }
+
+    [MethodImpl(MethodImplOptions.AggressiveInlining)]
+    public bool IsBetter(ISingleObjectiveSolutionScope<TSolution> a, ISingleObjectiveSolutionScope<TSolution> b) {
+      return IsBetter(a.Fitness, b.Fitness);
+    }
+    [MethodImpl(MethodImplOptions.AggressiveInlining)]
+    public bool IsBetter(double a, double b) {
+      return double.IsNaN(b) && !double.IsNaN(a)
+        || Problem.Maximization && a > b
+        || !Problem.Maximization && a < b;
+    }
+
+    public void AddBreedingResult(ISingleObjectiveSolutionScope<TSolution> a, ISingleObjectiveSolutionScope<TSolution> b, ISingleObjectiveSolutionScope<TSolution> child) {
+      if (IsBetter(a, b))
+        BreedingStat.Add(Tuple.Create(a.Fitness, b.Fitness, child.Fitness));
+      else BreedingStat.Add(Tuple.Create(b.Fitness, a.Fitness, child.Fitness));
+    }
+
+    public void AddRelinkingResult(ISingleObjectiveSolutionScope<TSolution> a, ISingleObjectiveSolutionScope<TSolution> b, ISingleObjectiveSolutionScope<TSolution> child) {
+      if (IsBetter(a, b))
+        RelinkingStat.Add(Tuple.Create(a.Fitness, b.Fitness, child.Fitness));
+      else RelinkingStat.Add(Tuple.Create(b.Fitness, a.Fitness, child.Fitness));
+    }
+
+    public void AddDelinkingResult(ISingleObjectiveSolutionScope<TSolution> a, ISingleObjectiveSolutionScope<TSolution> b, ISingleObjectiveSolutionScope<TSolution> child) {
+      if (IsBetter(a, b))
+        DelinkingStat.Add(Tuple.Create(a.Fitness, b.Fitness, child.Fitness));
+      else DelinkingStat.Add(Tuple.Create(b.Fitness, a.Fitness, child.Fitness));
+    }
+
+    public void AddSamplingResult(ISingleObjectiveSolutionScope<TSolution> sample) {
+      SamplingStat.Add(Tuple.Create(Population.Average(x => x.Fitness), sample.Fitness));
+    }
+
+    public void AddHillclimbingResult(ISingleObjectiveSolutionScope<TSolution> input, ISingleObjectiveSolutionScope<TSolution> outcome) {
+      HillclimbingStat.Add(Tuple.Create(input.Fitness, outcome.Fitness));
+    }
+
+    public void AddTabuwalkingResult(ISingleObjectiveSolutionScope<TSolution> input, ISingleObjectiveSolutionScope<TSolution> outcome) {
+      AdaptivewalkingStat.Add(Tuple.Create(input.Fitness, outcome.Fitness));
+    }
+
     #region IExecutionContext members
     public IAtomicOperation CreateOperation(IOperator op) {
@@ -254,4 +666,32 @@
     public IAtomicOperation CreateChildOperation(IOperator op, IScope s) {
       return new ExecutionContext(this, op, s);
+    }
+    #endregion
+
+    #region Math Helper
+    // normal distribution CDF (left of x) for N(0;1) standard normal distribution
+    // from http://www.johndcook.com/blog/csharp_phi/
+    // license: "This code is in the public domain. Do whatever you want with it, no strings attached."
+    // added: 2016-11-19 21:46 CET
+    protected static double Phi(double x) {
+      // constants
+      double a1 = 0.254829592;
+      double a2 = -0.284496736;
+      double a3 = 1.421413741;
+      double a4 = -1.453152027;
+      double a5 = 1.061405429;
+      double p = 0.3275911;
+
+      // Save the sign of x
+      int sign = 1;
+      if (x < 0)
+        sign = -1;
+      x = Math.Abs(x) / Math.Sqrt(2.0);
+
+      // A&S formula 7.1.26
+      double t = 1.0 / (1.0 + p * x);
+      double y = 1.0 - (((((a5 * t + a4) * t) + a3) * t + a2) * t + a1) * t * Math.Exp(-x * x);
+
+      return 0.5 * (1.0 + sign * y);
     }
     #endregion
